/*' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
' Copyright (c) 2006 Agilent Technologies.  All Rights Reserved.		   '
'                                                                          '
' Agilent Technologies provides programming samples for illustration       '
' purposes only.  This sample program assumes that you are familiar        '
' with the programming language being demonstrated and the tools used      '
' to create and debug procedures.  Agilent support engineers can help      '
' answer questions relating to the functionality of the software           '
' components provided by Agilent, but they will not modify these samples   '
' to provide added functionality or construct procedures to meet your      '
' specific needs.                                                          '
' You have a royalty-free right to use, modify, reproduce, and distribute  '
' this sample program (and/or any modified version) in any way you find    '
' useful, provided that you agree that Agilent has no warranty,            '
' obligations, or liability for any sample programs.                       '
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
'  AgilentU2121 Digital Input Examples
'
' This program is an example program intended for use with
' Microsoft C Sharp and the Agilent IVI COM objects.
'
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
'  Microsoft C Sharp Programming Examples
*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

//Added to use the agilent AgilentU2121 interface
using Agilent.AgilentU2121.Interop;

namespace DigitalInput
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class DigitalInput : System.Windows.Forms.Form
	{
		private AgilentU2121Class agilentU2121;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox dioStr;
		private System.Windows.Forms.Button initButton;
		private System.Windows.Forms.GroupBox digitalGroupBox;
		private System.Windows.Forms.Button readButton;
		private System.Windows.Forms.ListBox resultBox;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DigitalInput()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DigitalInput));
			this.label1 = new System.Windows.Forms.Label();
			this.dioStr = new System.Windows.Forms.TextBox();
			this.initButton = new System.Windows.Forms.Button();
			this.digitalGroupBox = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.resultBox = new System.Windows.Forms.ListBox();
			this.readButton = new System.Windows.Forms.Button();
			this.digitalGroupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Visa Resource Name:";
			// 
			// dioStr
			// 
			this.dioStr.Location = new System.Drawing.Point(160, 16);
			this.dioStr.Name = "dioStr";
			this.dioStr.Size = new System.Drawing.Size(312, 20);
			this.dioStr.TabIndex = 1;
			this.dioStr.Text = "";
			// 
			// initButton
			// 
			this.initButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.initButton.Location = new System.Drawing.Point(480, 16);
			this.initButton.Name = "initButton";
			this.initButton.Size = new System.Drawing.Size(104, 24);
			this.initButton.TabIndex = 2;
			this.initButton.Text = "Initialize";
			this.initButton.Click += new System.EventHandler(this.initButton_Click);
			// 
			// digitalGroupBox
			// 
			this.digitalGroupBox.Controls.Add(this.label2);
			this.digitalGroupBox.Controls.Add(this.resultBox);
			this.digitalGroupBox.Controls.Add(this.readButton);
			this.digitalGroupBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Underline, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.digitalGroupBox.Location = new System.Drawing.Point(16, 48);
			this.digitalGroupBox.Name = "digitalGroupBox";
			this.digitalGroupBox.Size = new System.Drawing.Size(568, 176);
			this.digitalGroupBox.TabIndex = 3;
			this.digitalGroupBox.TabStop = false;
			this.digitalGroupBox.Text = " Digital Input";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(16, 88);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(248, 64);
			this.label2.TabIndex = 2;
			this.label2.Text = "Press \"Read Word\" button to read word from Input Channel 1";
			// 
			// resultBox
			// 
			this.resultBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.resultBox.ItemHeight = 16;
			this.resultBox.Location = new System.Drawing.Point(280, 24);
			this.resultBox.Name = "resultBox";
			this.resultBox.Size = new System.Drawing.Size(272, 132);
			this.resultBox.TabIndex = 1;
			// 
			// readButton
			// 
			this.readButton.Enabled = false;
			this.readButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.readButton.Location = new System.Drawing.Point(16, 32);
			this.readButton.Name = "readButton";
			this.readButton.Size = new System.Drawing.Size(248, 32);
			this.readButton.TabIndex = 0;
			this.readButton.Text = "Read Word";
			this.readButton.Click += new System.EventHandler(this.readButton_Click);
			// 
			// DigitalInput
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 238);
			this.Controls.Add(this.digitalGroupBox);
			this.Controls.Add(this.initButton);
			this.Controls.Add(this.dioStr);
			this.Controls.Add(this.label1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "DigitalInput";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Digital Input";
			this.digitalGroupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new DigitalInput());
		}

		/// <summary>
		/// Initialize the AgilentU212X
		/// </summary>
		private void initButton_Click(object sender, System.EventArgs e)
		{
		
			try
			{

				agilentU2121 = new AgilentU2121Class();
				agilentU2121.Initialize(dioStr.Text, false, false, "");

				readButton.Enabled=true;
				
			}
			catch(System.Exception ex)
			{
				MessageBox.Show("Open failed on " + dioStr.Text + " " + ex.Source + "  " + ex.Message, "Error" , MessageBoxButtons.OK, MessageBoxIcon.Error); 
            
			}

		}

		/// <summary>
		/// Read word for Input Channel 1
		/// </summary>
		
		private void readButton_Click(object sender, System.EventArgs e)
		{
			int result=0;

			try
			{
				AgilentU2121InputChannel Input = agilentU2121.InputChannels.get_Item("InputChannel1");
				Input.ReadWord(ref result);
				resultBox.Items.Add("Input Channel 1: "+ result.ToString());
			}

			catch( System.Exception ex)
			{
				MessageBox.Show("Fail to read word for Input Channel 1. {"+ex.Message+"}","Error");
			}
		}

		
	}
}
