/*' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
' Copyright (c) 2006 Agilent Technologies.  All Rights Reserved.		   '
'                                                                          '
' Agilent Technologies provides programming samples for illustration       '
' purposes only.  This sample program assumes that you are familiar        '
' with the programming language being demonstrated and the tools used      '
' to create and debug procedures.  Agilent support engineers can help      '
' answer questions relating to the functionality of the software           '
' components provided by Agilent, but they will not modify these samples   '
' to provide added functionality or construct procedures to meet your      '
' specific needs.                                                          '
' You have a royalty-free right to use, modify, reproduce, and distribute  '
' this sample program (and/or any modified version) in any way you find    '
' useful, provided that you agree that Agilent has no warranty,            '
' obligations, or liability for any sample programs.                       '
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
'  AgilentU2121 Digital Filter Examples
'
' This program is an example program intended for use with
' Microsoft C++ and the Agilent IVI COM objects.
'
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
*/

namespace DigitalFilter
{
	//Added to use the agilent U2121 interface
	using namespace Agilent::AgilentU2121::Interop;
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::GroupBox *  digitalGroupBox;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::Button *  filterButton;
	private: System::Windows::Forms::Button *  initButton;
	private: System::Windows::Forms::TextBox *  dioStr;
	private: System::Windows::Forms::Label *  label1;
	
	private: AgilentU2121Class * agilentU2121 ;
	

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::Resources::ResourceManager *  resources = new System::Resources::ResourceManager(__typeof(DigitalFilter::Form1));
			this->digitalGroupBox = new System::Windows::Forms::GroupBox();
			this->label2 = new System::Windows::Forms::Label();
			this->filterButton = new System::Windows::Forms::Button();
			this->initButton = new System::Windows::Forms::Button();
			this->dioStr = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->digitalGroupBox->SuspendLayout();
			this->SuspendLayout();
			// 
			// digitalGroupBox
			// 
			this->digitalGroupBox->Controls->Add(this->label2);
			this->digitalGroupBox->Controls->Add(this->filterButton);
			this->digitalGroupBox->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Underline, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->digitalGroupBox->Location = System::Drawing::Point(16, 48);
			this->digitalGroupBox->Name = S"digitalGroupBox";
			this->digitalGroupBox->Size = System::Drawing::Size(512, 120);
			this->digitalGroupBox->TabIndex = 7;
			this->digitalGroupBox->TabStop = false;
			this->digitalGroupBox->Text = S" Digital Filter ";
			// 
			// label2
			// 
			this->label2->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->label2->Location = System::Drawing::Point(72, 80);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(360, 24);
			this->label2->TabIndex = 2;
			this->label2->Text = S"Press \"Set Filter\" button to enable filter interval as 1 second";
			// 
			// filterButton
			// 
			this->filterButton->Enabled = false;
			this->filterButton->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->filterButton->Location = System::Drawing::Point(24, 32);
			this->filterButton->Name = S"filterButton";
			this->filterButton->Size = System::Drawing::Size(464, 32);
			this->filterButton->TabIndex = 0;
			this->filterButton->Text = S"Set Filter";
			this->filterButton->Click += new System::EventHandler(this, filterButton_Click);
			// 
			// initButton
			// 
			this->initButton->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->initButton->Location = System::Drawing::Point(424, 16);
			this->initButton->Name = S"initButton";
			this->initButton->Size = System::Drawing::Size(104, 24);
			this->initButton->TabIndex = 6;
			this->initButton->Text = S"Initialize";
			this->initButton->Click += new System::EventHandler(this, initButton_Click);
			// 
			// dioStr
			// 
			this->dioStr->Location = System::Drawing::Point(160, 16);
			this->dioStr->Name = S"dioStr";
			this->dioStr->Size = System::Drawing::Size(256, 20);
			this->dioStr->TabIndex = 5;
			this->dioStr->Text = S"";
			// 
			// label1
			// 
			this->label1->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->label1->Location = System::Drawing::Point(16, 16);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(136, 24);
			this->label1->TabIndex = 4;
			this->label1->Text = S"Visa Resource Name:";
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(544, 182);
			this->Controls->Add(this->digitalGroupBox);
			this->Controls->Add(this->initButton);
			this->Controls->Add(this->dioStr);
			this->Controls->Add(this->label1);
			this->Icon = (__try_cast<System::Drawing::Icon *  >(resources->GetObject(S"$this.Icon")));
			this->Name = S"Form1";
			this->Text = S"Digital Filter";
			this->digitalGroupBox->ResumeLayout(false);
			this->ResumeLayout(false);

		}	
	
		//Initialise AgilentU2121
		private: System::Void initButton_Click(System::Object *  sender, System::EventArgs *  e)
			 {

				 try{
					agilentU2121 = new AgilentU2121Class();
					agilentU2121->Initialize(dioStr->Text, true, true, "");
					filterButton->Enabled=true;
					}
				 catch(System::Exception * ex)
				 {
					 MessageBox::Show(ex->Message, "Fail to Initialise AgilentU2121 ", MessageBoxButtons::OK, MessageBoxIcon::Error );
				 }
			 }
		// Enable filter interval as 1 second
		private: System::Void filterButton_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 try{

				 //Set filter interval
				 agilentU2121->DigitalFilter->set_Interval(1);
				 
				 //Enable Filter
				 agilentU2121->DigitalFilter->set_Enabled(true);
			 }
			 catch(System::Exception * ex)
			 {
				 MessageBox::Show(ex->Message, "Fail to enable Digital Filter ", MessageBoxButtons::OK, MessageBoxIcon::Error );
				
			 }
		 }

};
}


