/*' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
' Copyright (c) 2006 Agilent Technologies.  All Rights Reserved.		   '
'                                                                          '
' Agilent Technologies provides programming samples for illustration       '
' purposes only.  This sample program assumes that you are familiar        '
' with the programming language being demonstrated and the tools used      '
' to create and debug procedures.  Agilent support engineers can help      '
' answer questions relating to the functionality of the software           '
' components provided by Agilent, but they will not modify these samples   '
' to provide added functionality or construct procedures to meet your      '
' specific needs.                                                          '
' You have a royalty-free right to use, modify, reproduce, and distribute  '
' this sample program (and/or any modified version) in any way you find    '
' useful, provided that you agree that Agilent has no warranty,            '
' obligations, or liability for any sample programs.                       '
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
'  AgilentU2121 Powerup Examples
'
' This program is an example program intended for use with
' Microsoft C++ and the Agilent IVI COM objects.
'
' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""'
*/
#include <stdio.h>

namespace Powerup
{
	//Added to use the agilent U2121 interface
	using namespace Agilent::AgilentU2121::Interop;

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::GroupBox *  digitalGroupBox;
	private: System::Windows::Forms::Label *  label3;
	private: System::Windows::Forms::Button *  queryButton;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::ListBox *  resultBox;
	private: System::Windows::Forms::Button *  pudButton;
	private: System::Windows::Forms::Button *  initButton;
	private: System::Windows::Forms::TextBox *  dioStr;
	private: System::Windows::Forms::Label *  label1;

	private: AgilentU2121Class * agilentU2121;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->digitalGroupBox = new System::Windows::Forms::GroupBox();
			this->label3 = new System::Windows::Forms::Label();
			this->queryButton = new System::Windows::Forms::Button();
			this->label2 = new System::Windows::Forms::Label();
			this->resultBox = new System::Windows::Forms::ListBox();
			this->pudButton = new System::Windows::Forms::Button();
			this->initButton = new System::Windows::Forms::Button();
			this->dioStr = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->digitalGroupBox->SuspendLayout();
			this->SuspendLayout();
			// 
			// digitalGroupBox
			// 
			this->digitalGroupBox->Controls->Add(this->label3);
			this->digitalGroupBox->Controls->Add(this->queryButton);
			this->digitalGroupBox->Controls->Add(this->label2);
			this->digitalGroupBox->Controls->Add(this->resultBox);
			this->digitalGroupBox->Controls->Add(this->pudButton);
			this->digitalGroupBox->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Underline, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->digitalGroupBox->Location = System::Drawing::Point(16, 48);
			this->digitalGroupBox->Name = S"digitalGroupBox";
			this->digitalGroupBox->Size = System::Drawing::Size(568, 264);
			this->digitalGroupBox->TabIndex = 7;
			this->digitalGroupBox->TabStop = false;
			this->digitalGroupBox->Text = S" Powerup ";
			// 
			// label3
			// 
			this->label3->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->label3->Location = System::Drawing::Point(16, 200);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(248, 56);
			this->label3->TabIndex = 4;
			this->label3->Text = S"Press \"Query Output\" button to query output channel 1 after reconnect the instrum" 
				S"ent";
			// 
			// queryButton
			// 
			this->queryButton->Enabled = false;
			this->queryButton->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->queryButton->Location = System::Drawing::Point(16, 144);
			this->queryButton->Name = S"queryButton";
			this->queryButton->Size = System::Drawing::Size(248, 32);
			this->queryButton->TabIndex = 3;
			this->queryButton->Text = S"Query Output";
			this->queryButton->Click += new System::EventHandler(this, queryButton_Click);
			// 
			// label2
			// 
			this->label2->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->label2->Location = System::Drawing::Point(16, 80);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(248, 48);
			this->label2->TabIndex = 2;
			this->label2->Text = S"Press \"Set Powerup\" button to set powerup state as \"255\" to Output Channel1";
			// 
			// resultBox
			// 
			this->resultBox->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->resultBox->ItemHeight = 16;
			this->resultBox->Location = System::Drawing::Point(280, 24);
			this->resultBox->Name = S"resultBox";
			this->resultBox->Size = System::Drawing::Size(272, 212);
			this->resultBox->TabIndex = 1;
			// 
			// pudButton
			// 
			this->pudButton->Enabled = false;
			this->pudButton->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->pudButton->Location = System::Drawing::Point(16, 32);
			this->pudButton->Name = S"pudButton";
			this->pudButton->Size = System::Drawing::Size(248, 32);
			this->pudButton->TabIndex = 0;
			this->pudButton->Text = S"Set Powerup";
			this->pudButton->Click += new System::EventHandler(this, pudButton_Click);
			// 
			// initButton
			// 
			this->initButton->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->initButton->Location = System::Drawing::Point(480, 16);
			this->initButton->Name = S"initButton";
			this->initButton->Size = System::Drawing::Size(104, 24);
			this->initButton->TabIndex = 6;
			this->initButton->Text = S"Initialize";
			this->initButton->Click += new System::EventHandler(this, initButton_Click);
			// 
			// dioStr
			// 
			this->dioStr->Location = System::Drawing::Point(160, 16);
			this->dioStr->Name = S"dioStr";
			this->dioStr->Size = System::Drawing::Size(312, 20);
			this->dioStr->TabIndex = 5;
			this->dioStr->Text = S"";
			// 
			// label1
			// 
			this->label1->Font = new System::Drawing::Font(S"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, (System::Byte)0);
			this->label1->Location = System::Drawing::Point(16, 16);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(136, 24);
			this->label1->TabIndex = 4;
			this->label1->Text = S"Visa Resource Name:";
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->ClientSize = System::Drawing::Size(600, 326);
			this->Controls->Add(this->digitalGroupBox);
			this->Controls->Add(this->initButton);
			this->Controls->Add(this->dioStr);
			this->Controls->Add(this->label1);
			this->Name = S"Form1";
			this->Text = S"Powerup";
			this->digitalGroupBox->ResumeLayout(false);
			this->ResumeLayout(false);

		}	
		
		///<summary>
		///Initialise AgilentU2121
		/// </summary>
	private: System::Void initButton_Click(System::Object *  sender, System::EventArgs *  e)
			 {
				 try{
					agilentU2121 = new AgilentU2121Class();
					agilentU2121->Initialize(dioStr->Text, true, true, "");
					pudButton->Enabled=true;
					}
				 catch(System::Exception * ex)
				 {
					 MessageBox::Show(ex->Message, "Fail to Initialise AgilentU2121 ", MessageBoxButtons::OK, MessageBoxIcon::Error );
				 }
			 }
        /// <summary>
		/// Set powerup state as "255" to Output Channel1
		/// </summary>
	private: System::Void pudButton_Click(System::Object *  sender, System::EventArgs *  e)
			{
				System::Windows::Forms::DialogResult result=System::Windows::Forms::DialogResult::No;

                 try{
					 agilentU2121->Powerup->set_State("OutputChannel1",255);

					 do{
						 result=MessageBox::Show("Unplug and plug back instrument to observe effect. Have you plug back instrument?", 
							 "Instructions", MessageBoxButtons::YesNo, MessageBoxIcon::Question);
					 }
					 while(result!=System::Windows::Forms::DialogResult::Yes);

					 queryButton->Enabled=true;
				 }
				 catch(System::Exception * ex)
				 {
					MessageBox::Show(ex->Message, "Fail to set powerup state for Output Channel 1", MessageBoxButtons::OK, MessageBoxIcon::Error );
				 
				 }
			}

		/// <summary>
		/// Query output channel after reconnect the instrument
		/// </summary>
	private: System::Void queryButton_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			  int result=0;
			  char str1[255]="";
	
             try
			 {
			 	 //initialise U2121 instrument
			 	 agilentU2121 = new AgilentU2121Class();
				 agilentU2121->Initialize(dioStr->Text, false, false, "");

				 //read back the powerup setting
				 AgilentU2121OutputChannel * output=agilentU2121->OutputChannels->get_Item("OutputChannel1");	
				 output->QueryLastByte(&result);

				 int i=sprintf(str1,"Output Channel 1 : %d", result);
				 String *str=str1;
				 resultBox->Items->Add(str);
			 }
			 catch(System::Exception * ex)
			 {
			 	 MessageBox::Show(ex->Message, "Fail to request output ", MessageBoxButtons::OK, MessageBoxIcon::Error );
				 
			 }
		 }

};
}


